#! /usr/local/bin/perl
#############################################################################
#  
#   File: customer.pl
#
#  
#
#   Input: assgns7.html
#          CGI input ('QUERY_STRING') 
#          QUERY_STRING: Entries = Name;
#                                  Address; 
#                                  Social Security Number; 
#                                  Single rooms,Double rooms and Suites on I,II#                                 ,III,IV and V floors.
#   Output: HTML version of Hotel registration.
#
#   Description:Creates a Hotel registration List from the information gained i#n the input.                
#         
#
#
#############################################################################
#  
#   MAIN FUNCTION
#
#############################################################################


&PrintHeader;
&ReadEntry&&
&PrintResult;
&ProcessIt;


#############################################################################
#  
#   SUBROUTINES
#
#############################################################################



sub ReadEntry {
&ReadParse;
$name=$in{'name'};
$address=$in{'address'};
$SSN=$in{'SSN'};
$Days=$in{'Days'};
$room_Single=$in{'room'};
print " $room_Single ";
$room_Double=$in{'Double'};
$room_Suite=$in{'Suite'};
$Floors=$in{'I'};
$Floors=$in{'II'};
$Floors=$in{'III'};
$Floors=$in{'IV'};
$Floors=$in{'V'};
return 1;
}

sub PrintResult {
print "<TITLE>HOTEL REGISTRATION COUNTER </TITLE>";

printf"<H3>\n";
print"$name";
printf"<H3>\n";
print"$address";
printf"<H3>\n";
print"$SSN";
printf"<H3>\n";
printf"No. Of Days \n";
print"$Days";
print"<h3>\n";
print "Thank you for filling out this form";

print"<p><br>\n";
return 1;
}

sub ProcessIt{
if((($room_Single) eq "S") || (($Floors) eq "I")) 
   {print "Rooms available $Floor  are 122,154 & 177\n";}
elsif ((($room_Single) eq "Single") && (($Floors) eq "II"))
   {print "Rooms available are 202,245 & 269\n";}
elsif ((($room_Single) eq "Single") && (($Floors) eq "III"))
   {print "Rooms available are 333,356 & 380\n";}
elsif ((($room_Single) eq "Single") && (($Floors) eq "IV"))
   {print "Rooms available are 400,456 & 488\n";}
elsif ((($room_Single) eq "Single") && (($Floors) eq "V"))
   {print "Rooms available are 514,540 & 576\n";}
else {print"Try next floor!";}

if ((($room_Double) eq "Double") && (($Floors) eq "I"))
   {print "Rooms available are 112,122 & 188\n";}
elsif ((($room_Double) eq "Double") && (($Floors) eq "II"))
   {print "Rooms available are 221,254 & 279\n";}
elsif ((($room_Double) eq "Double") && (($Floors) eq "III"))
   {print "Rooms available are 322,325 & 365\n";}
elsif ((($room_Double) eq "Double") && (($Floors) eq "IV"))
   {print "Rooms available are 431,435 & 467\n";}
elsif ((($room_Double) eq "Double") && (($Floors) eq "V"))
   {print "Rooms available are 539,541 & 574\n";}
else {print "Try next floor!";}

if ((($room_Suite) eq "Suite") && (($Floors) eq "I"))
   {print "Rooms available are 143,187 & 191\n";}
elsif ((($room_Suite) eq "Suite") && (($Floors)eq "II"))
   {print "Rooms available are 211,269 & 283\n";}
elsif ((($room_Suite) eq "Suite") && (($Floors)eq "III"))
   {print "Rooms available are 349,359 & 378\n";}
elsif ((($room_Suite) eq "Suite") && (($Floors) eq "IV"))
   {print "Rooms available are 401,419 & 482\n";}
elsif ((($room_Suite) eq "Suite") && (($Floors) eq "V"))
   {print "Rooms available are 515,538 & 583 \n";}


else {print "We are sorry!There are no rooms available";}

print"Thanks! Visit us again!\n";

return 1;
}



##############################################################################
#
#  Get information from fill-out form.
#
##############################################################################


# Returns the magic line which tells WWW that this is an HTML document
sub PrintHeader {
  print "Content-type: text/html\n\n";
  print "\n";
}

# reads the arguments passed from the form
sub ReadParse {
    local ($i, $loc, $key, $val);

    if ($ENV{'REQUEST_METHOD'} eq "GET") {     
       $in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
        $in .=getc;
       }
    }else {
    $in = <STDIN>;
    print "$in\n";
  }

     @in = split(/&/,$in);

    foreach $i (0 .. $#in) {
      $in[$i] =~ s/\+/ /g;                          # Convert plus's to spaces
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
                                # Convert %XX from hex numbers to alphanumeric
      $loc = index($in[$i], "=");                  # Split onto key and value.
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
   }
   return 1; 
}





