#!/oracle/oracle_home/bin/oraperl

# Print MIME type
print qq|Content-type: text/html\n\n|;

# Set up the debuging flag.
$ora_debug = shift if $ARGV[0] =~ /^-#/;

# $ENV{'ORACLE_HOME'} = '/usr/oracle';
# $ENV{'ORACLE_SID'} = '';


read(STDIN, $incoming, $ENV{'CONTENT_LENGTH'});
&cgi_decode;

$name = ($FORM{'name'}) ? $FORM{'name'} : undef;
$last_name = ($FORM{'last_name'}) ? $FORM{'last_name'} : undef;

# Specify the user_name-name/password and select a database.
$userid = "cps616";
$passwd = "cps616";
$database = $ENV{'ORACLE_SID'};

# Login the ORACLE SQL.
$lda = &ora_login($database, $userid, $passwd) || die $ora_errstr;

# Cursor for quering phone number by inputing the name

# jy debug
$phone_cursor = $name;


# Open a complicate query cursor
$csr = &ora_open($lda, $phone_cursor);

# Assign acctial values in SQL statement
&ora_bind($csr, $name, $last_name);

# Print HTML TABLE header
print qq|<H3>The following records were returned by the submitted SQL query:</H3>\n|;


# jy debug
print qq|\n<h3>Query:</h3> \n|;
print qq|$name \n|;
print qq|<hr>\n|;
print qq|\n<h3>Result: </h3> \n|;

print qq|<TABLE BORDER>\n|;
# jy remove headings

# Fetch the record into array variables
while (@data = &ora_fetch($csr)) {
    print qq|<TR>\n|;
    foreach $attr (@data) {
        print qq|<TD>$attr</TD>\n|;
    }
    print qq|</TR>\n|;
}
print qq|</TABLE>\n|;

# Close the cursor
&ora_close($csr);

# Logoff.
&ora_logoff($lda);

sub cgi_decode {
    @pairs = split(/&/, $incoming);

    foreach (@pairs) {
        ($name, $value) = split(/=/, $_);

        $name  =~ tr/+/ /;
        $value =~ tr/+/ /;
        $name  =~ s/%([A-F0-9][A-F0-9])/pack("C", hex($1))/gie;
        $value =~ s/%([A-F0-9][A-F0-9])/pack("C", hex($1))/gie;

        #### Strip out semicolons unless for special character
        $value =~ s/;/$$/g;
        $value =~ s/&(\S{1,6})$$/&\1;/g;
        $value =~ s/$$/ /g;

        $value =~ s/\|/ /g;
        $value =~ s/^!/ /g; ## Allow exclamation points in sentences

        #### Skip blank text entry fields
        next if ($value eq "");

        #### Check for "assign-dynamic" field names
        #### Mainly for on-the-fly input names, especially checkboxes
        if ($name =~ /^assign-dynamic/) {
            $name = $value;
            $value = "on";
        }

        #### Allow for multiple values of a single name
        $FORM{$name} .= ", " if ($FORM{$name});

        $FORM{$name} .= $value;
    }
}
