#! /usr/local/bin/perl -w

##########################################################################
#
# File:         ST.pl
# Author:       Shrideep Pallickara
# Description:  Form interface for sending electronic birthday greeting
#               message to Sachin Tendulkar
#
##########################################################################


$mailprogram='/usr/lib/sendmail -t -n';

&PrintHeader;
&ReadEntry;
&CreateBirthdayWish;
&PrintResult;
&SendBirthdayWish;


##########################################################################
#
#This subroutine assigns the data to the variables from ReadParse.
#
##########################################################################

sub ReadEntry {
    &ReadParse;     # Read arguments passed from fill-out form
    $Card =$in{'Card'};
    $PersonalComment =$in{'PersonalComment'};
    $YourName =$in{'YourName'};
    $YourEmail =$in{'YourEmail'};
    $RecipientsEmail =$in{'RecipientsEmail'};
    $Signature =$in{'Signature'};
    $site = "http://osprey7.npac.syr.edu:3768/users-docs/mispirli/1/$YourName".".html";
    $y=0;
    $r=0;
    $y=index($YourEmail, "@");
    $r=index($RecipientsEmail, "@");
    if(length($YourEmail)==0)  {
	$error=-1; 
	print "<HTML><BODY bgColor=white><CENTER><P><BLINK><FONT SIZE=5>Please fill in Your E-Mail Address.</BLINK></CENTER><P></BODY></HTML>";        
    } 
    if(length($RecipientsEmail)==0)  {
	$error=-1; 
	print "<HTML><BODY bgColor=white><CENTER><P><BLINK><FONT SIZE=5>Pleae fill in the Recipient's E-Mail Address.</BLINK></CENTER><P></BODY></HTML>";
    }
    if($y == -1) {
	$error=-1;
	print "<HTML><BODY bgColor=white><CENTER><P><BLINK><FONT SIZE=5>You are missing <B>@</B> symbol in your e-mail address!</BLINK></CENTER><P></BODY></HTML>";
    }
    if($r == -1) {
	$error=-1;
	print "<HTML><BODY bgColor=white><CENTER><P><BLINK><FONT SIZE=5>You are missing <B>@</B> symbol in recipient's e-mail address!</BLINK></CENTER></BODY></HTML>";
    }
    return 1;
}


##########################################################################
#
# Get information from fill-out form
#
##########################################################################

sub PrintHeader {
    print "Content-type: text/html\n\n";
}


# reads the arguments passed from the form
sub ReadParse {
    local ($i, $loc, $key, $val);
    
    if ($ENV{'REQUEST_METHOD'} eq "GET") {    # Read in text
	$in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
	for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
	    $in .=getc;
	}
    } else 
    {  # can be used for debugging on command line
	$in = <STDIN>;
	print "$in\n";
    }
    
    @in = split(/&/,$in);
    
    foreach $i (0 .. $#in) {
	$in[$i] =~ s/\+/ /g;                          # Convert plus's to spaces
	$in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
	# Convert %XX from hex numbers to alphanumeric
	$loc = index($in[$i], "=");                  # Split onto key and value.
	$key = substr($in[$i],0,$loc);
	$val = substr($in[$i],$loc+1);
	$in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
	$in{$key} .= $val;
    }
    return 1; 
}



##########################################################################
#
# This subroutine creates the birthday wish card
#
##########################################################################

sub CreateBirthdayWish {
    $file = "/servers/cgi-http-class/htdoc/users-docs/mispirli/1/$YourName".".html";
    open(BdayCard,">>$file") || die ("Could not open $file file.");
    print BdayCard "<HTML><HEAD><TITLE>JUST FOR YOU</TITLE></HEAD>";
    print BdayCard "<BODY bgColor=white><CENTER>";
    print BdayCard "<img src=\"$Card\" width=300><P>";
    print BdayCard "$PersonalComment<P>";
    print BdayCard "$Signature<BR>";
    print BdayCard "$YourName";
    print BdayCard "</BODY></HTML>";
    close(BdayCard);
    return 1;
}


##########################################################################
#
# This subroutine prints out the output
#
##########################################################################

sub PrintResult {
    print "<HTML><HEAD><TITLE>PREVIEW OF YOUR CARD</TITLE></HEAD>";
    print "<BODY bgColor=white><CENTER>";
    print "<img src=\"../../users-docs/mispirli/1/$Card\" width=300><P>";
    print "$PersonalComment<P>";
    print "$Signature<BR>";
    print "$YourName";
    print "</BODY></HTML>";
    return 1;
}



##########################################################################
#
# This subroutine sends e-mails both to the sender and to the recipient
#
##########################################################################

sub SendBirthdayWish{
    $mycopy="mispirli\@npac.syr.edu\n";
    if (open (MAIL, "|$mailprogram")) {
	print MAIL "To: \"\" \<$RecipientsEmail\>\n";
        print MAIL "Cc: $mycopy\n\n";
	print MAIL "Hello $RecipientsEmail\n";
	print MAIL "You have a Birthday wish from $YourName \<$YourEmail\>\n";
        print MAIL "To view the card, please visit $site";
	close (MAIL);
	return 1;
    }
}


