#! /usr/local/bin/perl

# this will be /usr/local/bin/perl
#############################################################################
#  
# Programmer:  Rob Baker
# Date:            12/06/96
# Description: This script sets up a form for the meeting times for final presentations
#
#############################################################################
#  
#   MAIN FUNCTION
#
#############################################################################

&PrintHeader;
&PrintResult;


#############################################################################
#  
#   SUBROUTINES
#
#############################################################################



sub PrintResult {
$counter = 0;
print "<!-- -->\n";
print "<HTML>\n";
print "<HEAD>\n";
print "  <TITLE>Final Project Presentations</TITLE>\n";
print "</HEAD>\n";

print "<BODY TEXT=\"#000000\" LINK=\"#66CDAA\" VLINK=\"#B0C4DE\"\n";
print "     ALINK=\"#FF0000\"  BGCOLOR=\"#FFFFFF\">\n";

print "<CENTER><HR WIDTH=\"50%\">\n";
print "<H2>CPS606/CPS600/CPS406 Final Project Presentations</H2>\n";
print "<HR WIDTH=\"50%\"><P>\n";
print "<p>Type your name/names in an available textfield, and then press the Submit Time button.  Groups may sign up for one time. <p><HR WIDTH=\"50%\"><P>\n";

# Form submission will call helper perl script to process and write data
print "<FORM ACTION=\"cps606helper.pl\" METHOD=\"POST\" ><TABLE BORDER WIDTH=\"50%\" CELLSPACING=\"5\" CELLPADDING=\"5\">\n";

open(TIMESHEET, "nancytimesheet") || die "time sheet not found or permissions incorrectly set"; 
flock(TIMESHEET, 2);
@nameVal = <TIMESHEET>;
@reversearray = reverse(@nameVal);

### read dates from the first line
    $line = pop(@reversearray);
    chop($line);
    @dates = split(/:/,$line);

##  Print dates - this version assumes 4!!!
print "<B><TR><TD>Time</TD><TD>$dates[0]</TD><TD>$dates[1]</TD>\n";
print "<TD>$dates[2]</TD><td>$dates[3]</td></TR></B>";
##

while(@reversearray) {
    $line = pop(@reversearray);
    chop($line);
    ($time, $name, $nextname, $anothername, $fourthname) = split(/:/,$line);  
    
  print "<TR><TD>$time</TD><TD>";
  if ($name eq "blank") {
    $thename = name.$counter;
    print "<INPUT TYPE=\"text\" Size=20 Name=\"$thename\"></TD>\n";
###############################################################################
## Table output can be customized to print a form field or X's by adding or
## customizing checks within the below if statements.  name, thenextname, and
## theothername are the cells for the 3 dates which can be filled in.  An 
## example of customizing this output is to uncomment the print XXXXXX statement
## below, and then whenever blank is read in X's are outputed.    

  #print "XXXXXXXXXX</TD>\n";
}
  elsif ($name ne "blank"){
    print "$name</TD>\n";
    }
  if ($nextname eq "blank") {
    $thenextname = nextname.$counter; 
    print "<TD><INPUT TYPE=\"text\" Size=20 Name=\"$thenextname\"></TD>";
   }
  elsif ($nextname ne "blank") {
    print "<TD>$nextname</TD>";
  }
  if ($anothername eq "blank") {
    $theothername = anothername.$counter; 
    print "<TD><INPUT TYPE=\"text\" Size=20 Name=\"$theothername\"></TD>";
   }
#  elsif ($anothername eq "") {
#    print "<TD>XXXXXXXXXXXX</TD>";
#  }
  elsif ($anothername ne "blank") {
    print "<TD>$anothername</TD>";
  }
  if ($fourthname eq "blank") {
    $thefourthname = fourthname.$counter; 
    print "<TD><INPUT TYPE=\"text\" Size=20 Name=\"$thefourthname\"></TD>";
   }
  elsif ($fourthname ne "blank") {
    print "<TD>$fourthname</TD>";
  }
  print"</TR>\n";
  $counter++;
 close(TIMESHEET);
 flock(TIMESHEET, 8);
 }#end of while statement
print "<INPUT Type=submit Value=\"Submit Time\">\n"; 
print "<INPUT Type=reset Value=\"Reset Time\">\n"; 
print "</FORM></TABLE>\n";

    
 
print "</CENTER></BODY></HTML>\n";

  return 1;
}

# Returns the magic line which tells WWW that this is an HTML document
sub PrintHeader {
  print "Content-type: text/html\n\n";
  print "\n";
}                                                           







