#! /usr/local/bin/perl
#
#
# writes the student registration info to a file
#
#############################################################################
#  
#   GLOBAL VARIABLES
#
#############################################################################


$dataFile="/servers/cgi-http-class/htdoc/users-docs/msen7/classlist.db";

$title="<header><title>Class List Registration</title></header>\n";
$signature="<hr><hr>\n";
$background="";

#############################################################################
#  
#   MAIN FUNCTION
#
#############################################################################

&ReadEntry;
&printResults;

#############################################################################
#  
#   SUBROUTINES
#
#############################################################################

sub ReadEntry {
   &ReadParse;     # Read arguments passed from fill-out form
   return 1;
}


sub printResults {

   &printHeader;

   if ($in{"section"} eq "check") { &checkRecord; }

   elsif ($in{"section"} eq "add") {
       &addRecord;
   }

#  print join(" - ", %in);

   &printFooter;
   return 1;
}

##############################################################################
#
#  Get information from fill-out form.
#
##############################################################################


# Returns the magic line which tells WWW that this is an HTML document
sub printHeader {
  print "Content-type: text/html\n\n";
  print "<html> $title<body background=$background>";
}

sub printFooter {
  print "$signature </body></html>\n";
}

#*********************************************************************
# Introduction
# Send a fill out form to find out whether to teach or browse.
#*********************************************************************

sub intro {


}

sub addRecord {


$date=`date`;
chop($date);
open(UPLOAD, ">>$dataFile");
flock(UPLOAD,2);
print UPLOAD "$in{'course'}\|$in{'ssn'}\|$in{'name'}\|$in{'email'}\|$in{'uid'}\|$in{'dept'}\|$in{'class'}\|$in{'url'}";
for($i=1;$i<=$in{'numOfQ'};$i++){
    print UPLOAD "\|$in{'q'.$i}";
}
print UPLOAD "\n";
flock(UPLOAD,8);
close(UPLOAD);


print "<h3>Thank you for your cooperation. .</h3>";

}

sub errorUploads {

print "<h1>Error</h1>Could not add your record. Please go back, and try again!";

}



##############################################################################
#
#  Get information from fill-out form.
#
##############################################################################


# reads the arguments passed from the form
sub ReadParse {
    local ($i, $loc, $key, $val);

    if ($ENV{'REQUEST_METHOD'} eq "GET") {                      # Read in text
       $in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
        $in .=getc;
      }
  } else 
  {  # can be used for debugging on command line
      $in = <STDIN>;
    #  print "$in\n";
  }

    @in = split(/&/,$in);

    foreach $i (0 .. $#in) {
      $in[$i] =~ s/\+/ /g;                          # Convert plus's to spaces
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
                                # Convert %XX from hex numbers to alphanumeric
      $loc = index($in[$i], "=");                  # Split onto key and value.
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
   }
   return 1; 
}






