#!/usr/local/bin/perl

##############################################################################
#
#  Get information from fill-out form.
#
##############################################################################
$imagedir="http://osprey7.npac.syr.edu:3768/users-docs/msen7//images";


# Returns the magic line which tells WWW that this is an HTML document
sub PrintHeader {
    print "Content-type: text/html\n\n\n";

}

# reads the arguments passed from the form
sub ReadParse {
    local ($i, $loc, $key, $val);

    if ($ENV{'REQUEST_METHOD'} eq "GET") {                      # Read in text
	$in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
	for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
	    $in .=getc;
	}
    } else 
    {  # can be used for debugging on command line
	$in = <STDIN>;
	print "$in\n";
    }
    
    @in = split(/&/,$in);

    foreach $i (0 .. $#in) {
      $in[$i] =~ s/\+/ /g;                          # Convert plus's to spaces
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
      # Convert %XX from hex numbers to alphanumeric
      $loc = index($in[$i], "=");                  # Split onto key and value.
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
    }
    return 1; 
}
1;
