#! /usr/local/bin/perl
#############################################################################
#  
#   File:    add2db.pl
#
#   Input:  oksig = value of user choice (whether to enter data in db or not) 
#
#
#############################################################################

$dbfile = "data.db";
&ReadEntry;
print "Content-type: text/html\n\n";
&ProcessData; exit;

if ( $oksig eq "Ship it !" ) {
        &ProcessData;   
} elsif ( $oksig eq "Forget it !" ) {
        &ReloadMainMenu;
}
else{ # should not happen
}
exit;

#############################################################################
#  
#   SUBROUTINES
#
#############################################################################

#  Read arguments passed from html doc
sub ReadEntry {
   &ReadParse;
   $name    = $FORM{'name'};
   $phone   = $FORM{'phno'};
   $oksig = $FORM{'add'};
        
        return 1;
}

#  Decode information passed from the form
sub ReadParse {
    local ($in, @pairs, $pair, $key, $val);
 
    if ($ENV{'REQUEST_METHOD'} eq "GET") {       # Read in text
       $in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
       read (STDIN, $in, $ENV{'CONTENT_LENGTH'});
    } else {  # can be used for debugging on command line
      $in = <STDIN>;
#      print "$in\n";
    }
 
    @pairs = split(/&/,$in);
 
    foreach $pair (@pairs) {
      # Split into key and value pair.
      ($key, $val) = split(/=/, $pair);
      #Convert +'s to spaces
      $key  =~ tr/+/ /;
      $val  =~ tr/+/ /;
      # Convert %XX from hex numbers to alphanumeric
      $key  =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/ge;
      $val  =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/ge;
      # put \0 as the multiple separator
      $FORM{$key} .= '\0' if (defined($FORM{$key}));
      $FORM{$key} .= $val;
   }
   return 1;
}
 

#  Let user know that the data has been entered
sub ProcessData {
        
        # Update the database:
        &UpdateDBFile;
        
        # Print an HTML page:
        #print "Content-type: text/html\n\n";
        #print "Content-type: text/html\n\n";
        # Opening HTML statements:
        print "<HTML>\n";
        print "<HEAD>\n";
        print "<TITLE>Result of Data Entry</TITLE>\n";
        print "</HEAD>\n";
        print "<body bgcolor=white>" ;
        print "<P>   Your data has been entered in the database. </P>" ;
        print "<P>   Your data will be made available for other users to 
browse. </P>" ;

        print "<P><a 
href=\"http://osprey7.npac.syr.edu:3768/cps616spring97-docs/cb97kba/asgn8.html\">Back to Main Menu</a></P>" ;
        
        print "\n</BODY>\n";
        print "</HTML>\n";
                
        return 1;
}

#   add data to the database file
sub UpdateDBFile {

   open (DBFILE, ">>$dbfile") || die("Cannot open database file : data.db");
   flock (DBFILE, 2);
   print DBFILE "$name|$phone\n";
   flock (DBFILE, 8);
   close DBFILE;
                
        return 1;
}

# Reload the original HTML form:
sub ReloadMainMenu {
print 
'Location: 
http://osprey7.npac.syr.edu:3768/cps616spring97-docs/cb97kba/asgn8.html';
        print "\n\n";
                
        return 1;
}
